Attribute VB_Name = "Module1"
Option Explicit
'
'     tricky.bas
'
' Copyright(c) 2001 yoh(yohhoy)
'

' Win32API
Private Type WNDCLASS
    style         As Long
    lpfnWndProc   As Long
    cbClsExtra    As Long
    cbWndExtra    As Long
    hinstance     As Long
    hIcon         As Long
    hCursor       As Long
    hbrBackground As Long
    lpszMenuName  As String
    lpszClassName As String
End Type
Private Type MSG
    hwnd    As Long
    message As Long
    wParam  As Long
    lParam  As Long
    time    As Long
    pt_x    As Long 'pt.x
    pt_y    As Long 'pt.y
End Type

Private Declare Function RegisterClass Lib "user32" Alias "RegisterClassA" (Class As WNDCLASS) As Long
Private Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As Long) As Long
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hinstance As Long, lpParam As Any) As Long
Private Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Private Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetMessage Lib "user32" Alias "GetMessageA" (lpMsg As MSG, ByVal hwnd As Long, ByVal wMsgFilterMin As Long, ByVal wMsgFilterMax As Long) As Long
Private Declare Function TranslateMessage Lib "user32" (lpMsg As MSG) As Long
Private Declare Function DispatchMessage Lib "user32" Alias "DispatchMessageA" (lpMsg As MSG) As Long
Private Declare Sub PostQuitMessage Lib "user32" (ByVal nExitCode As Long)
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function LoadCursor Lib "user32" Alias "LoadCursorA" (ByVal hinstance As Long, ByVal lpCursorName As Long) As Long
Private Declare Function LoadIcon Lib "user32" Alias "LoadIconA" (ByVal hinstance As Long, ByVal lpIconName As Long) As Long
Private Declare Function CreateMenu Lib "user32" () As Long
Private Declare Function CreatePopupMenu Lib "user32" () As Long
Private Declare Function AppendMenu Lib "user32" Alias "AppendMenuA" (ByVal hMenu As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lpNewItem As Any) As Long
Private Declare Function DestroyMenu Lib "user32" (ByVal hMenu As Long) As Long

Private Declare Function GetActiveWindow Lib "user32" () As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
        

Private Const WM_CREATE  As Long = &H1
Private Const WM_DESTROY As Long = &H2
Private Const WM_CLOSE   As Long = &H10
Private Const WM_COMMAND As Long = &H111
Private Const CS_VREDRAW As Long = &H1
Private Const CS_HREDRAW As Long = &H2
Private Const IDI_APPLICATION As Long = 32512
Private Const IDC_ARROW As Long = 32512
Private Const COLOR_BTNFACE As Long = 15
Private Const WS_OVERLAPPED As Long = &H0
Private Const WS_MAXIMIZEBOX As Long = &H10000
Private Const WS_MINIMIZEBOX As Long = &H20000
Private Const WS_THICKFRAME  As Long = &H40000
Private Const WS_SYSMENU     As Long = &H80000
Private Const WS_CAPTION     As Long = &HC00000
Private Const WS_OVERLAPPEDWINDOW As Long = (WS_OVERLAPPED Or WS_CAPTION Or WS_SYSMENU Or WS_THICKFRAME Or WS_MINIMIZEBOX Or WS_MAXIMIZEBOX)
Private Const CW_USEDEFAULT As Long = &H80000000
Private Const SW_SHOW As Long = 5
Private Const MF_STRING As Long = &H0
Private Const MF_POPUP  As Long = &H10

' module variable
Private m_hInstance As Long

Private Const WNDCLSNAME As String = "TrickyVbWndCls"
Private Const IDM_EXIT = 1


Public Sub HKCreator()
    Dim wc As WNDCLASS
    Dim hMenu As Long, hSubMenu As Long
    Dim hwnd As Long
    Dim message As MSG
    
    '???
    m_hInstance = GetModuleHandle(0)
    
    '???????????
    With wc
        .style = CS_VREDRAW Or CS_HREDRAW
        .lpfnWndProc = funcaddr(AddressOf WindowProc)
        .cbClsExtra = 0
        .cbWndExtra = 0
        .hinstance = m_hInstance
        .hIcon = LoadIcon(0, IDI_APPLICATION)
        .hCursor = LoadCursor(0, IDC_ARROW)
        .hbrBackground = COLOR_BTNFACE + 1
        .lpszMenuName = vbNullString
        .lpszClassName = WNDCLSNAME
    End With
    Call RegisterClass(wc)
    
    '??????
    'hMenu = CreateMenu()
    'hSubMenu = CreatePopupMenu()
    'Call AppendMenu(hMenu, MF_STRING Or MF_POPUP, hSubMenu, "&File")
    'Call AppendMenu(hSubMenu, MF_STRING, IDM_EXIT, "&Exit")
    
    '???????
    hwnd = CreateWindowEx(0, WNDCLSNAME, "tricky", _
                          WS_OVERLAPPEDWINDOW, _
                          CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, _
                          -3, 0, m_hInstance, 0)
    'Call ShowWindow(hwnd, SW_SHOW)
    
    '????????
    'Do While (GetMessage(message, 0, 0, 0))
    '    Call TranslateMessage(message)
    '    Call DispatchMessage(message)
    'Loop
    
    '??????
    'Call DestroyMenu(hSubMenu)
    'Call DestroyMenu(hMenu)
    
    '--------------------------
    ' Register the hotkey.
    If RegisterHotKey(hwnd, HOTKEY_ID, MOD_ALT, VK_F10) = 0 Then
        MsgBox "Error registering hotkey."
        'Unload Me
    End If
    
    OldWindowProc = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf NewWindowProc)
End Sub

'
' ???????????
'
Private Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    
    WindowProc = 0
    
    Select Case uMsg
    Case WM_CREATE
        '
    
    Case WM_COMMAND
        Select Case (wParam And &HFFFF)
        Case IDM_EXIT '[Exit]
            '?????????
            Call SendMessage(hwnd, WM_CLOSE, 0, 0)
        End Select
    
    Case WM_DESTROY
        '??????????
        Call PostQuitMessage(0)
    
    Case Else
        WindowProc = DefWindowProc(hwnd, uMsg, wParam, lParam)
    
    End Select

End Function


Private Function funcaddr(ByVal addr As Long) As Long
    funcaddr = addr
End Function


' Look for the WM_HOTKEY message.
Private Function NewWindowProc(ByVal hwnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Const WM_NCDESTROY = &H82
    Const WM_HOTKEY = &H312

    ' If we're being destroyed,
    ' restore the original WindowProc and
    ' unregister the hotkey.
    If MSG = WM_NCDESTROY Then
        SetWindowLong hwnd, GWL_WNDPROC, OldWindowProc
        UnregisterHotKey hwnd, HOTKEY_ID
    End If

    ' See if this is the WM_HOTKEY message.
    If MSG = WM_HOTKEY Then Hotkey

    ' Process the message normally.
    NewWindowProc = CallWindowProc(OldWindowProc, hwnd, MSG, wParam, lParam)
End Function

Private Sub Hotkey()
    'txtTimes.Text = txtTimes.Text & time & vbCrLf
    'txtTimes.SelStart = Len(txtTimes.Text)

    'If Me.WindowState = vbMinimized Then Me.WindowState = vbNormal
    'Me.SetFocus
    
    Dim awhnd As Long
     
     'Private Declare Function GetForegroundWindow Lib "user32.dll" () As Int32
    'Private LastCheckedForegroundTitle As String = "" 'Title of the foreground window when last checked

    'Gets the title of the active window
        Dim MyStr As String
        
        
        awhnd = GetActiveWindow
        
        MyStr = GetWindowText(awhnd, MyStr, 100)
        'MyStr = MyStr.Substring(0, InStr(MyStr, Chr(0)) - 1)
        Debug.Print MyStr
    
     
     
    awhnd = GetActiveWindow
    
    Dim Title As String * 255
    
    ' get the title of the active window
    GetWindowText awhnd, Title, Len(Title)
    
    MsgBox Trim(Title)
    
    
End Sub
