VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Class1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Type WNDCLASSEX
    cbSize          As Long '
    style           As Long
    lpfnWndProc     As Long '
    cbClsExtra      As Long
    cbWndExtra2     As Long
    hinstance       As Long '
    hIcon           As Long
    hCursor         As Long
    hbrBackground   As Long
    lpszMenuName    As Long
    lpszClassName   As Long '
    hIconSm         As Long
End Type


Private Declare Function GetClassLong Lib "user32" Alias "GetClassLongW" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetClassLong Lib "user32" Alias "SetClassLongW" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function UnregisterClass Lib "user32" Alias "UnregisterClassW" (ByVal lpClassName As Long, ByVal hinstance As Long) As Long
Private Declare Function RegisterClassEx Lib "user32" Alias "RegisterClassExW" (pcWndClassEx As WNDCLASSEX) As Integer
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExW" (ByVal dwExStyle As Long, ByVal lpClassName As Long, ByVal lpWindowName As Long, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hinstance As Long, lpParam As Any) As Long
Private Declare Function VirtualFree Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal dwFreeType As Long) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function HeapFree Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, ByVal lpMem As Long) As Long
Private Declare Function GetProcessHeap Lib "kernel32" () As Long


Private Const MEM_RELEASE               As Long = &H8000&
Private Const HWND_MESSAGE              As Long = -3
Private Const HEAP_NO_SERIALIZE         As Long = &H1

Private Const MsgClass                  As String = "DUMMY_CLASS"

Dim lpSThrd         As Long
Dim lpWndProc       As Long
Dim lpParam         As Long

Dim hwnd            As Long
Dim isInit          As Boolean


Private Sub Class_Initialize()
    Dim cls     As WNDCLASSEX
    'Dim isFirst As Boolean
    Dim count   As Long
    
    cls.cbSize = Len(cls)
    
    'If GetClassInfoEx(App.hInstance, StrPtr(MsgClass), cls) = 0 Then
    '
    '    If Not CreateAsm Then Exit Sub
    '
        cls.hinstance = App.hinstance
        cls.lpfnWndProc = lpWndProc
        cls.lpszClassName = StrPtr(MsgClass)
        'cls.cbClsextra = 8
        
        If RegisterClassEx(cls) = 0 Then Exit Sub
        
        'isFirst = True
 
    'End If
    
    hwnd = CreateWindowEx(0, MsgClass, "", 0, 0, 0, 0, 0, HWND_MESSAGE, 0, App.hinstance, ByVal 0&)
    'hwnd = CreateWindowEx(0,strptr(MsgClass),MsgClass
    If hwnd = 0 Then Exit Sub
    
    'If isFirst Then
    '
        SetClassLong hwnd, 0, lpSThrd: count = 1
    'Else
    '
    '    lpSThrd = GetClassLong(hWnd, 0):    lpMThrd = lpSThrd + &H28:   lpWndProc = lpSThrd + &H56
    '    count = GetClassLong(hWnd, 4) + 1
    '
    'End If
    
    SetClassLong hwnd, 4, count
    
    isInit = True
   '
   '
   '
    ''--------------------------
    ' Register the hotkey.
    If RegisterHotKey(hwnd, HOTKEY_ID, MOD_ALT, VK_F10) = 0 Then
        MsgBox "Error registering hotkey."
        Unload Me
    End If

    ' Subclass the TextBox to watch for
    ' WM_HOTKEY messages.
    OldWindowProc = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf NewWindowProc)
    
    
End Sub
 
Private Sub Class_Terminate()
    
    Dim count   As Long
    
    'If Not isInit Then Exit Sub
        
    'Abort
    If lpParam Then HeapFree GetProcessHeap(), HEAP_NO_SERIALIZE, lpParam
    
    'count = GetClassLong(hWnd, 4) - 1
    
    DestroyWindow hwnd
    
    If count = 0 Then
        
        VirtualFree lpSThrd, 100, MEM_RELEASE
        UnregisterClass StrPtr(MsgClass), App.hinstance
        
    End If
    
End Sub

